# coding: utf-8

"""
    Collibra Catalog Classification API

    Version 2 of the Catalog Classification API offers functionality related to the classification process and facilitates searching for and managing the associations between a data class and a data category. Use version 1 of the API for managing classifications and legacy data classes.   # noqa: E501

    OpenAPI spec version: 2.0.0-unstable
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DataClassDataCategoryConnection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'data_class': 'Classification',
        'data_category': 'NamedResourceReferenceImpl',
        'created_by': 'str',
        'created_on': 'int',
        'last_modified_by': 'str',
        'last_modified_on': 'int',
        'system': 'bool',
        'resource_type': 'ResourceType'
    }

    attribute_map = {
        'id': 'id',
        'data_class': 'dataClass',
        'data_category': 'dataCategory',
        'created_by': 'createdBy',
        'created_on': 'createdOn',
        'last_modified_by': 'lastModifiedBy',
        'last_modified_on': 'lastModifiedOn',
        'system': 'system',
        'resource_type': 'resourceType'
    }

    def __init__(self, id=None, data_class=None, data_category=None, created_by=None, created_on=None, last_modified_by=None, last_modified_on=None, system=None, resource_type=None):  # noqa: E501
        """DataClassDataCategoryConnection - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._data_class = None
        self._data_category = None
        self._created_by = None
        self._created_on = None
        self._last_modified_by = None
        self._last_modified_on = None
        self._system = None
        self._resource_type = None
        self.discriminator = None
        self.id = id
        if data_class is not None:
            self.data_class = data_class
        if data_category is not None:
            self.data_category = data_category
        if created_by is not None:
            self.created_by = created_by
        if created_on is not None:
            self.created_on = created_on
        if last_modified_by is not None:
            self.last_modified_by = last_modified_by
        if last_modified_on is not None:
            self.last_modified_on = last_modified_on
        if system is not None:
            self.system = system
        self.resource_type = resource_type

    @property
    def id(self):
        """Gets the id of this DataClassDataCategoryConnection.  # noqa: E501

        The ID of the represented object (entity).  # noqa: E501

        :return: The id of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DataClassDataCategoryConnection.

        The ID of the represented object (entity).  # noqa: E501

        :param id: The id of this DataClassDataCategoryConnection.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def data_class(self):
        """Gets the data_class of this DataClassDataCategoryConnection.  # noqa: E501


        :return: The data_class of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: Classification
        """
        return self._data_class

    @data_class.setter
    def data_class(self, data_class):
        """Sets the data_class of this DataClassDataCategoryConnection.


        :param data_class: The data_class of this DataClassDataCategoryConnection.  # noqa: E501
        :type: Classification
        """

        self._data_class = data_class

    @property
    def data_category(self):
        """Gets the data_category of this DataClassDataCategoryConnection.  # noqa: E501


        :return: The data_category of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: NamedResourceReferenceImpl
        """
        return self._data_category

    @data_category.setter
    def data_category(self, data_category):
        """Sets the data_category of this DataClassDataCategoryConnection.


        :param data_category: The data_category of this DataClassDataCategoryConnection.  # noqa: E501
        :type: NamedResourceReferenceImpl
        """

        self._data_category = data_category

    @property
    def created_by(self):
        """Gets the created_by of this DataClassDataCategoryConnection.  # noqa: E501

        The ID of the user who created this resource.  # noqa: E501

        :return: The created_by of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this DataClassDataCategoryConnection.

        The ID of the user who created this resource.  # noqa: E501

        :param created_by: The created_by of this DataClassDataCategoryConnection.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def created_on(self):
        """Gets the created_on of this DataClassDataCategoryConnection.  # noqa: E501

        The Unix timestamp in milliseconds (in UTC time standard) of the resource creation date.  # noqa: E501

        :return: The created_on of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: int
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this DataClassDataCategoryConnection.

        The Unix timestamp in milliseconds (in UTC time standard) of the resource creation date.  # noqa: E501

        :param created_on: The created_on of this DataClassDataCategoryConnection.  # noqa: E501
        :type: int
        """

        self._created_on = created_on

    @property
    def last_modified_by(self):
        """Gets the last_modified_by of this DataClassDataCategoryConnection.  # noqa: E501

        The ID of the user who last modified this resource.  # noqa: E501

        :return: The last_modified_by of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: str
        """
        return self._last_modified_by

    @last_modified_by.setter
    def last_modified_by(self, last_modified_by):
        """Sets the last_modified_by of this DataClassDataCategoryConnection.

        The ID of the user who last modified this resource.  # noqa: E501

        :param last_modified_by: The last_modified_by of this DataClassDataCategoryConnection.  # noqa: E501
        :type: str
        """

        self._last_modified_by = last_modified_by

    @property
    def last_modified_on(self):
        """Gets the last_modified_on of this DataClassDataCategoryConnection.  # noqa: E501

        The Unix timestamp in milliseconds (in UTC time standard) the resource last modified date.  # noqa: E501

        :return: The last_modified_on of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: int
        """
        return self._last_modified_on

    @last_modified_on.setter
    def last_modified_on(self, last_modified_on):
        """Sets the last_modified_on of this DataClassDataCategoryConnection.

        The Unix timestamp in milliseconds (in UTC time standard) the resource last modified date.  # noqa: E501

        :param last_modified_on: The last_modified_on of this DataClassDataCategoryConnection.  # noqa: E501
        :type: int
        """

        self._last_modified_on = last_modified_on

    @property
    def system(self):
        """Gets the system of this DataClassDataCategoryConnection.  # noqa: E501

        Whether this is a system resource or not.  # noqa: E501

        :return: The system of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: bool
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this DataClassDataCategoryConnection.

        Whether this is a system resource or not.  # noqa: E501

        :param system: The system of this DataClassDataCategoryConnection.  # noqa: E501
        :type: bool
        """

        self._system = system

    @property
    def resource_type(self):
        """Gets the resource_type of this DataClassDataCategoryConnection.  # noqa: E501


        :return: The resource_type of this DataClassDataCategoryConnection.  # noqa: E501
        :rtype: ResourceType
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this DataClassDataCategoryConnection.


        :param resource_type: The resource_type of this DataClassDataCategoryConnection.  # noqa: E501
        :type: ResourceType
        """
        if resource_type is None:
            raise ValueError("Invalid value for `resource_type`, must not be `None`")  # noqa: E501

        self._resource_type = resource_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DataClassDataCategoryConnection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataClassDataCategoryConnection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
